using UnityEngine;
using System;
using System.Collections.Generic;
using System.Collections;
using System.IO;
using UnityEngine.UI;
using System.Linq;
using TMPro;
using UnityEngine.Events;

namespace Mod
{
    public class Mod
    {
        public static void Main()
        {

CategoryBuilder.Create("Wolfenstein: TNO", "Stuff from Wolfostono.", ModAPI.LoadSprite("wolfostono.png"));

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Assault Rifle"), //item to derive from
        NameOverride = "R Wolfenstein: TNO - Assault Rifle 1960", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "blacc cool", //new item description
        CategoryOverride = ModAPI.FindCategory("Wolfenstein: TNO"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("ar60/ar60image.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //setting the sprite
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ar60/ar60.png");

            //getting the FirearmBehaviour for later manipulation
            var firearm = Instance.GetComponent<FirearmBehaviour>();

            //set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
            firearm.ShotSounds = new AudioClip[]
            {
                ModAPI.LoadSound("ar60/ar60_fire1.wav"),
				ModAPI.LoadSound("ar60/ar60_fire2.wav"),
				ModAPI.LoadSound("ar60/ar60_fire3.wav"),
            };

            Instance.FixColliders();
        }
    }
); 

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("AK-47"), //item to derive from
        NameOverride = "R Wolfenstein: TNO - Assault Rifle 1946", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Based on STG-44", //new item description
        CategoryOverride = ModAPI.FindCategory("Wolfenstein: TNO"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("ar46/ar46image.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //setting the sprite
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ar46/ar46.png");

            //getting the FirearmBehaviour for later manipulation
            var firearm = Instance.GetComponent<FirearmBehaviour>();

	    firearm.AutomaticFireInterval = 0.125f;

            //set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
            firearm.ShotSounds = new AudioClip[]
            {
                ModAPI.LoadSound("ar46/ar46_fire.wav"),
            };

            Instance.FixColliders();
        }
    }
); 

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Assault Rifle"), //item to derive from
        NameOverride = "R Wolfenstein: TOB - Assault Rifle 1946-T", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "An improved AR46", //new item description
        CategoryOverride = ModAPI.FindCategory("Wolfenstein: TNO"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("ar46t/ar46timage.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //setting the sprite
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ar46t/ar46t.png");

            //getting the FirearmBehaviour for later manipulation
            var firearm = Instance.GetComponent<FirearmBehaviour>();

            //set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
            firearm.ShotSounds = new AudioClip[]
            {
                ModAPI.LoadSound("ar46t/ar46t_fire.wav"),
            };

            Instance.FixColliders();
        }
    }
); 

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Sniper Rifle"), //item to derive from
        NameOverride = "R Wolfenstein: TNO - AR Marksman", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "WHITE", //new item description
        CategoryOverride = ModAPI.FindCategory("Wolfenstein: TNO"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("marksman/marksmanimage.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //setting the sprite
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("marksman/marksman.png");

            //getting the FirearmBehaviour for later manipulation
            var firearm = Instance.GetComponent<FirearmBehaviour>();

            //set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
            firearm.ShotSounds = new AudioClip[]
            {
                ModAPI.LoadSound("marksman/marksman_fire1.wav"),
				ModAPI.LoadSound("marksman/marksman_fire2.wav"),
				ModAPI.LoadSound("marksman/marksman_fire3.wav"),
            };

            Instance.FixColliders();
        }
    }
); 

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rifle"), //item to derive from
        NameOverride = "R Wolfenstein: TOB - Bombenschuss", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Bombasus", //new item description
        CategoryOverride = ModAPI.FindCategory("Wolfenstein: TNO"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("bombasus/bombasusimage.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //setting the sprite
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("bombasus/bombasus.png");

            //getting the FirearmBehaviour for later manipulation
            var firearm = Instance.GetComponent<FirearmBehaviour>();

            //set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
            firearm.ShotSounds = new AudioClip[]
            {
                ModAPI.LoadSound("bombasus/bombasus.wav"),
            };

            Instance.FixColliders();
        }
    }
); 

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Blaster Rifle"), 
        NameOverride = "O Wolfenstein: TNO - Laserkraftwerk", 
        DescriptionOverride = "A prototype laser weapon found in the Da'at Yichud lab in London Nautica", 
        CategoryOverride = ModAPI.FindCategory("Wolfenstein: TNO"), 
        ThumbnailOverride = ModAPI.LoadSprite("lkw/lkwimage.png"), 
        AfterSpawn = (Instance) => 
        {
			
			Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("lkw/lkw.png");
			Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.3f;
			Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.3f;
			var blaster= Instance.GetComponent<BlasterBehaviour>();
			blaster.Clips= new AudioClip[]
			{
			ModAPI.LoadSound("lkw/lkw_fire1.wav"),
			ModAPI.LoadSound("lkw/lkw_fire2.wav"),
			ModAPI.LoadSound("lkw/lkw_fire3.wav"),
		};
			
			Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("lkw/lkw.png", 10);
			foreach (var c in Instance.GetComponents<Collider2D>())
			{
			GameObject.Destroy(c);
			}
			Instance.FixColliders();
			Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("lkw/lkw.png");
				
			foreach (Transform child in Instance.transform)
			if (child.name.Contains("light") || child.name.Contains("glow"))
			UnityEngine.Object.Destroy(child.gameObject);
			blaster.Recoil = 3.5f; 
			blaster.InaccuracyMultiplier = 0.0001f; 
			blaster.Automatic = true; 
			blaster.Interval = 0.25f; 
			Instance.GetComponent<BlasterBehaviour>().barrelPosition = new Vector2(0.87f,0.04f);

			var childObject = new GameObject("hgglow");
			childObject.transform.SetParent(Instance.transform);
			childObject.transform.localPosition = new Vector3(0, 0f);
			childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
			childObject.transform.localScale = new Vector3(1f, 1f);
			var childSprite = childObject.AddComponent<SpriteRenderer>();
			childSprite.sprite = ModAPI.LoadSprite("hg.png");
			childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
			childSprite.sortingLayerName = "Foreground";
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Pistol"), //item to derive from
        NameOverride = "P Wolfenstein: TNO/TOB - Luger 1946", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "parabello", //new item description
        CategoryOverride = ModAPI.FindCategory("Wolfenstein: TNO"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("luger46/luger46image.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //setting the sprite
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("luger46/luger46.png");

            //getting the FirearmBehaviour for later manipulation
            var firearm = Instance.GetComponent<FirearmBehaviour>();

            //set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
            firearm.ShotSounds = new AudioClip[]
            {
                ModAPI.LoadSound("luger46/luger46_1.wav"),
				ModAPI.LoadSound("luger46/luger46_2.wav"),
				ModAPI.LoadSound("luger46/luger46_3.wav"),
            };

            Instance.FixColliders();
        }
    }
); 

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Pistol"), //item to derive from
        NameOverride = "P Wolfenstein: TOB - Goldene Pistole", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "In TOB, you can unlock it by collecting every gold ingot collectible.", //new item description
        CategoryOverride = ModAPI.FindCategory("Wolfenstein: TNO"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("lugergoldenepistole/lugergoldenepistoleimage.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //setting the sprite
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("lugergoldenepistole/lugergoldenepistole.png");

            //getting the FirearmBehaviour for later manipulation
            var firearm = Instance.GetComponent<FirearmBehaviour>();

            //set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
            firearm.ShotSounds = new AudioClip[]
            {
                ModAPI.LoadSound("luger46/luger46_1.wav"),
				ModAPI.LoadSound("luger46/luger46_2.wav"),
				ModAPI.LoadSound("luger46/luger46_3.wav"),
            };

            Instance.FixColliders();
        }
    }
); 

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Pistol"), //item to derive from
        NameOverride = "P Wolfenstein: TNO - Luger 1960", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "lugere", //new item description
        CategoryOverride = ModAPI.FindCategory("Wolfenstein: TNO"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("luger60/luger60thumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //setting the sprite
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("luger60/luger60.png");

            //getting the FirearmBehaviour for later manipulation
            var firearm = Instance.GetComponent<FirearmBehaviour>();

            //set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
            firearm.ShotSounds = new AudioClip[]
            {
                ModAPI.LoadSound("luger60/luger60.wav"),
            };

            Instance.FixColliders();
        }
    }
); 

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Shotgun"), //item to derive from
        NameOverride = "S Wolfenstein: TNO - Automatic Shotgun", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "atomatik cool", //new item description
        CategoryOverride = ModAPI.FindCategory("Wolfenstein: TNO"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("shashlykhammer60/shashlykhammer60image.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //setting the sprite
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("shashlykhammer60/shashlykhammer60.png");

            //getting the FirearmBehaviour for later manipulation
            var firearm = Instance.GetComponent<FirearmBehaviour>();

           Cartridge customCartridge = ModAPI.FindCartridge("38 Special");
            customCartridge.name = "schock1960"; //set a name
            customCartridge.Damage *= 0.9f; //change the damage however you like
            customCartridge.StartSpeed *= 0.2f; //change the bullet velocity
            customCartridge.PenetrationRandomAngleMultiplier *= 0.2f;
            customCartridge.Recoil *= 0.6f; //change the recoil
            customCartridge.ImpactForce *= 0.8f; 

            firearm.Cartridge = customCartridge;
			firearm.Automatic = true;
			firearm.AutomaticFireInterval = 0.2f;

            //set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
            firearm.ShotSounds = new AudioClip[]
            {
                ModAPI.LoadSound("shashlykhammer60/sht1.wav"),
            };

            Instance.FixColliders();
        }
    }
); 

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Submachine Gun"), //item to derive from
        NameOverride = "O Wolfenstein: TNO - Thompson SMG", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Rapid", //new item description
        CategoryOverride = ModAPI.FindCategory("Wolfenstein: TNO"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("thmp/thmpimage.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //setting the sprite
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("thmp/thmp.png");

            //getting the FirearmBehaviour for later manipulation
            var firearm = Instance.GetComponent<FirearmBehaviour>();

            //set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
            firearm.ShotSounds = new AudioClip[]
            {
                ModAPI.LoadSound("thmp/thmp1.wav"),
				ModAPI.LoadSound("thmp/thmp2.wav"),
				ModAPI.LoadSound("thmp/thmp3.wav"),
            };

            Instance.FixColliders();
        }
    }
); 

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Pistol"), //item to derive from
        NameOverride = "P Wolfenstein: TNO - Luger 1960 Lunar Base Version", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "ce es go skin", //new item description
        CategoryOverride = ModAPI.FindCategory("Wolfenstein: TNO"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("luger60/luger60moonthumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //setting the sprite
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("luger60/luger60moon.png");

            //getting the FirearmBehaviour for later manipulation
            var firearm = Instance.GetComponent<FirearmBehaviour>();

            //set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
            firearm.ShotSounds = new AudioClip[]
            {
                ModAPI.LoadSound("luger60/luger60silenced.wav"),
            };

            Instance.FixColliders();
        }
    }
); 

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Shotgun"), //item to derive from
        NameOverride = "S Wolfenstein: TNO - Schockhammer 1946", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "shocc", //new item description
        CategoryOverride = ModAPI.FindCategory("Wolfenstein: TNO"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("shotun46/shotun46image.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //setting the sprite
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("shotun46/shotun46.png");

            //getting the FirearmBehaviour for later manipulation
            var firearm = Instance.GetComponent<FirearmBehaviour>();

   	    Cartridge customCartridge = ModAPI.FindCartridge("38 Special");
            customCartridge.name = "schock1946"; //set a name
            customCartridge.Damage *= 1.0f; //change the damage however you like
            customCartridge.StartSpeed *= 0.2f; //change the bullet velocity
            customCartridge.PenetrationRandomAngleMultiplier *= 0.2f;
            customCartridge.Recoil *= 0.7f; //change the recoil
            customCartridge.ImpactForce *= 1.0f; 

            firearm.Cartridge = customCartridge;

            //set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
            firearm.ShotSounds = new AudioClip[]
            {
                ModAPI.LoadSound("shotun46/shotun46.wav"),
            };

            Instance.FixColliders();
        }
    }
); 

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Grenade Launcher"), //item to derive from
        NameOverride = "O Wolfenstein: TOB - Kampfpistole", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "mein kampf", //new item description
        CategoryOverride = ModAPI.FindCategory("Wolfenstein: TNO"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("kampf/kampfimage.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //setting the sprite
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("kampf/kampf.png");
			Instance.FixColliders();

						AudioSource AS = Instance.AddComponent<AudioSource>();
                        AS.minDistance = 1;
                        AS.maxDistance = 9;


                        int index = 0;
                        AudioClip[] AudioData = new AudioClip[]
                        {
                            ModAPI.LoadSound("kampf/kampf.wav")
                        };
						
						Instance.AddComponent<UseEventTrigger>().Action = () =>
                        {
                            AS.clip = AudioData[index];
                            AS.Play();

                            index++;
                            if (index == AudioData.Length) index = 0;
                        };

                        SirenBehaviour sirenBehaviour = Instance.GetComponent<SirenBehaviour>();
                        sirenBehaviour.enabled = true;	 
        }
    }
); 

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Shotgun"), //item to derive from
        NameOverride = "S Wolfenstein: TNO/TOB - Double-Barreled Shotgun", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = ":cowboy:", //new item description
        CategoryOverride = ModAPI.FindCategory("Wolfenstein: TNO"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("dblbarrel/dblbarrelimage.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //setting the sprite
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("dblbarrel/dblbarrel.png");

            //getting the FirearmBehaviour for later manipulation
            var firearm = Instance.GetComponent<FirearmBehaviour>();

             Cartridge customCartridge = ModAPI.FindCartridge("38 Special");
            customCartridge.name = "dblbarrel1"; //set a name
            customCartridge.Damage *= 1.2f; //change the damage however you like
            customCartridge.StartSpeed *= 0.3f; //change the bullet velocity
            customCartridge.PenetrationRandomAngleMultiplier *= 0.3f;
            customCartridge.Recoil *= 0.9f; //change the recoil
            customCartridge.ImpactForce *= 1.3f; 

            firearm.Cartridge = customCartridge;

            firearm.ShotSounds = new AudioClip[]
            {
                ModAPI.LoadSound("dblbarrel/dblbarrel1.wav"),
				ModAPI.LoadSound("dblbarrel/dblbarrel2.wav"),
				ModAPI.LoadSound("dblbarrel/dblbarrel3.wav"),
            };

            Instance.FixColliders();
        }
    }
); 

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Shotgun"), //item to derive from
        NameOverride = "S Wolfenstein: TOB - Sawed-Off Shotgun", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "doom", //new item description
        CategoryOverride = ModAPI.FindCategory("Wolfenstein: TNO"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("dblbarrel/sawedoffimage.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //setting the sprite
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("dblbarrel/sawedoff.png");

            //getting the FirearmBehaviour for later manipulation
            var firearm = Instance.GetComponent<FirearmBehaviour>();

   	    Cartridge customCartridge = ModAPI.FindCartridge("38 Special");
            customCartridge.name = "dblbarrel"; //set a name
            customCartridge.Damage *= 1.2f; //change the damage however you like
            customCartridge.StartSpeed *= 0.4f; //change the bullet velocity
            customCartridge.PenetrationRandomAngleMultiplier *= 0.2f;
            customCartridge.Recoil *= 0.7f; //change the recoil
            customCartridge.ImpactForce *= 1.6f; 

            firearm.Cartridge = customCartridge;

            //set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
            firearm.ShotSounds = new AudioClip[]
            {
                ModAPI.LoadSound("dblbarrel/sawedoff1.wav"),
				ModAPI.LoadSound("dblbarrel/sawedoff2.wav"),
				ModAPI.LoadSound("dblbarrel/sawedoff3.wav"),
            };

            Instance.FixColliders();
        }
    }
); 

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Blaster"), 
        NameOverride = "O Wolfenstein: TNO - Lasercutter", 
        DescriptionOverride = "lasero", 
        CategoryOverride = ModAPI.FindCategory("Wolfenstein: TNO"), 
        ThumbnailOverride = ModAPI.LoadSprite("lasercutter/lasercutterimage.png"), 
        AfterSpawn = (Instance) => 
        {
			
			Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("lasercutter/lasercutter.png");
			Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.2f;
			Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
			var blaster= Instance.GetComponent<BlasterBehaviour>();
			blaster.Clips= new AudioClip[]
			{
			ModAPI.LoadSound("lasercutter/lasercutter.wav"),
		};
			
			Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("lasercutter/lasercutter.png", 10);
			foreach (var c in Instance.GetComponents<Collider2D>())
			{
			GameObject.Destroy(c);
			}
			Instance.FixColliders();
			Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("lasercutter/lasercutter.png");
				
			foreach (Transform child in Instance.transform)
			if (child.name.Contains("light") || child.name.Contains("glow"))
			UnityEngine.Object.Destroy(child.gameObject);
			blaster.Recoil = 0.5f; 
			blaster.InaccuracyMultiplier = 0f; 
			blaster.Automatic = false; 
			blaster.Interval = 0.2f; 
			Instance.GetComponent<BlasterBehaviour>().barrelPosition = new Vector2(0.87f,0.04f);
			
			
			
			var childObject = new GameObject("hgglow");
			childObject.transform.SetParent(Instance.transform);
			childObject.transform.localPosition = new Vector3(0, 0f);
			childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
			childObject.transform.localScale = new Vector3(1f, 1f);
			var childSprite = childObject.AddComponent<SpriteRenderer>();
			childSprite.sprite = ModAPI.LoadSprite("hg.png");
			childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
			childSprite.sortingLayerName = "Foreground";
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Blaster"), 
        NameOverride = "O Wolfenstein: TNO - Maschinengewehr 1960", 
        DescriptionOverride = "lasero", 
        CategoryOverride = ModAPI.FindCategory("Wolfenstein: TNO"), 
        ThumbnailOverride = ModAPI.LoadSprite("mg60/mg60image.png"), 
        AfterSpawn = (Instance) => 
        {
			
			Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("mg60/mg60.png");
			Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.5f;
			Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.5f;
			var blaster= Instance.GetComponent<BlasterBehaviour>();
			blaster.Clips= new AudioClip[]
			{
			ModAPI.LoadSound("mg60/mg601.wav"),
			ModAPI.LoadSound("mg60/mg602.wav"),
			ModAPI.LoadSound("mg60/mg603.wav"),
		};
			
			Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("mg60/mg60.png", 10);
			foreach (var c in Instance.GetComponents<Collider2D>())
			{
			GameObject.Destroy(c);
			}
			Instance.FixColliders();
			Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("mg60/mg60.png");
				
			foreach (Transform child in Instance.transform)
			if (child.name.Contains("light") || child.name.Contains("glow"))
			UnityEngine.Object.Destroy(child.gameObject);
			blaster.Recoil = 0.2f; 
			blaster.InaccuracyMultiplier = 0.03f; 
			blaster.Automatic = true; 
			blaster.Interval = 0.08f; 
			Instance.GetComponent<BlasterBehaviour>().barrelPosition = new Vector2(0.87f,0.04f);
			
			
			
			var childObject = new GameObject("mg60glow");
			childObject.transform.SetParent(Instance.transform);
			childObject.transform.localPosition = new Vector3(0, 0f);
			childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
			childObject.transform.localScale = new Vector3(1f, 1f);
			var childSprite = childObject.AddComponent<SpriteRenderer>();
			childSprite.sprite = ModAPI.LoadSprite("mg60/mg60glow.png");
			childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
			childSprite.sortingLayerName = "Foreground";
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Blaster Rifle"), 
        NameOverride = "O Wolfenstein: TNO - Laser Rifle", 
        DescriptionOverride = "AR Marksman alt. fire mode.", 
        CategoryOverride = ModAPI.FindCategory("Wolfenstein: TNO"), 
        ThumbnailOverride = ModAPI.LoadSprite("marksman/marksmanlaserimage.png"), 
        AfterSpawn = (Instance) => 
        {
			
			Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("marksman/marksmanlaser.png");
			Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.3f;
			Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.3f;
			var blaster= Instance.GetComponent<BlasterBehaviour>();
			blaster.Clips= new AudioClip[]
			{
			ModAPI.LoadSound("marksman/marksmanlaser1.wav"),
			ModAPI.LoadSound("marksman/marksmanlaser2.wav"),
			ModAPI.LoadSound("marksman/marksmanlaser3.wav"),
		};
			
			Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("marksman/marksmanlaser.png", 10);
			foreach (var c in Instance.GetComponents<Collider2D>())
			{
			GameObject.Destroy(c);
			}
			Instance.FixColliders();
			Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("marksman/marksmanlaser.png");
				
			foreach (Transform child in Instance.transform)
			if (child.name.Contains("light") || child.name.Contains("glow"))
			UnityEngine.Object.Destroy(child.gameObject);
			blaster.Recoil = 0.1f; 
			blaster.InaccuracyMultiplier = 0.025f; 
			blaster.Automatic = true; 
			blaster.Interval = 0.1f; 
			Instance.GetComponent<BlasterBehaviour>().barrelPosition = new Vector2(0.87f,0.04f);
			
			
			
			var childObject = new GameObject("marksmanlaserglow");
			childObject.transform.SetParent(Instance.transform);
			childObject.transform.localPosition = new Vector3(0, 0f);
			childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
			childObject.transform.localScale = new Vector3(1f, 1f);
			var childSprite = childObject.AddComponent<SpriteRenderer>();
			childSprite.sprite = ModAPI.LoadSprite("marksman/marksmanlaser_glow.png");
			childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
			childSprite.sortingLayerName = "Foreground";
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Assault Rifle"), //item to derive from
        NameOverride = "O Wolfenstein: TNO - Maschinengewehr 1946", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "GRAY", //new item description
        CategoryOverride = ModAPI.FindCategory("Wolfenstein: TNO"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("mg46/mg46image.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //setting the sprite
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("mg46/mg46.png");

            //getting the FirearmBehaviour for later manipulation
            var firearm = Instance.GetComponent<FirearmBehaviour>();

	    firearm.AutomaticFireInterval = 0.05f;

            //set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
            firearm.ShotSounds = new AudioClip[]
            {
                ModAPI.LoadSound("mg46/mg461.wav"),
				ModAPI.LoadSound("mg46/mg462.wav"),
				ModAPI.LoadSound("mg46/mg463.wav"),
            };

            Instance.FixColliders();
        }
    }
); 

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Knife"), //item to get from
        NameOverride = "K Wolfenstein: TNO - Trench Knife", //name
        DescriptionOverride = "KNIFOUNG", //not needed
        CategoryOverride = ModAPI.FindCategory("Wolfenstein: TNO"), //category
        ThumbnailOverride = ModAPI.LoadSprite("knife/trenchknifeimage.png"), //thumnail image
        AfterSpawn = (Instance) => //after its spawned
        { 
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("knife/trenchknife.png"); //the texture for the item
            Instance.FixColliders(); //fix the colliders
        }  
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Knife"), //item to get from
        NameOverride = "K Wolfenstein: TNO - Knife 1960", //name
        DescriptionOverride = "Looks dope", //not needed
        CategoryOverride = ModAPI.FindCategory("Wolfenstein: TNO"), //category
        ThumbnailOverride = ModAPI.LoadSprite("knife/knife1960image.png"), //thumnail image
        AfterSpawn = (Instance) => //after its spawned
        { 
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("knife/knife1960.png"); //the texture for the item
            Instance.FixColliders(); //fix the colliders
        }  
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Knife"), //item to get from
        NameOverride = "K Wolfenstein: TNO - Kitchen Knife", //name
        DescriptionOverride = "It's in the beginning of the Asylum.", //not needed
        CategoryOverride = ModAPI.FindCategory("Wolfenstein: TNO"), //category
        ThumbnailOverride = ModAPI.LoadSprite("knife/kitchenknifeimage.png"), //thumnail image
        AfterSpawn = (Instance) => //after its spawned
        { 
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("knife/kitchenknife.png"); //the texture for the item
            Instance.FixColliders(); //fix the colliders
        }  
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Knife"), //item to get from
        NameOverride = "K Wolfenstein: TOB - Knife 1946", //name
        DescriptionOverride = "LONDON", //not needed
        CategoryOverride = ModAPI.FindCategory("Wolfenstein: TNO"), //category
        ThumbnailOverride = ModAPI.LoadSprite("knife/knife1946image.png"), //thumnail image
        AfterSpawn = (Instance) => //after its spawned
        { 
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("knife/knife1946.png"); //the texture for the item
            Instance.FixColliders(); //fix the colliders
        }  
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"), //item to get from
        NameOverride = "K Wolfenstein: TOB - Single Pipe", //name
        DescriptionOverride = "rura", //not needed
        CategoryOverride = ModAPI.FindCategory("Wolfenstein: TNO"), //category
        ThumbnailOverride = ModAPI.LoadSprite("knife/pipeimage.png"), //thumnail image
        AfterSpawn = (Instance) => //after its spawned
        { 
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("knife/pipe_single.png"); //the texture for the item
            Instance.FixColliders(); //fix the colliders
        }  
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"), //item to get from
        NameOverride = "K Wolfenstein: TOB - Left Pipe", //name
        DescriptionOverride = "rura", //not needed
        CategoryOverride = ModAPI.FindCategory("Wolfenstein: TNO"), //category
        ThumbnailOverride = ModAPI.LoadSprite("knife/pipeimage.png"), //thumnail image
        AfterSpawn = (Instance) => //after its spawned
        { 
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("knife/pipe_left.png"); //the texture for the item
            Instance.FixColliders(); //fix the colliders
        }  
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"), //item to get from
        NameOverride = "K Wolfenstein: TOB - Right Pipe", //name
        DescriptionOverride = "rura", //not needed
        CategoryOverride = ModAPI.FindCategory("Wolfenstein: TNO"), //category
        ThumbnailOverride = ModAPI.LoadSprite("knife/pipeimage.png"), //thumnail image
        AfterSpawn = (Instance) => //after its spawned
        { 
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("knife/pipe_right.png"); //the texture for the item
            Instance.FixColliders(); //fix the colliders
        }  
    }
);

}
    }
}